/***************************************************************************
 *   Copyright (C) 2008 by Andreas Silberstorff   *
 *   taki@Rivendell   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CHANNELLISTPROVIDERINTERFACE_H
#define CHANNELLISTPROVIDERINTERFACE_H

#include <Data/Channel>

#include <QVariant>
#include <QList>
#include <QString>

namespace KalvaPlugin {

/**
 * This class describes the interface for the channellistprovider.
 * @short ChannellistProviderInterface
 * @author Andreas Silberstorff <ml@andreas-silberstorff.de>
 * @version 1.0.91
 */

class ChannellistProviderInterface
{
public:
	virtual ~ChannellistProviderInterface() {};

	virtual void loadChannellist() = 0;
	
	/**
	 * Store a QList with Channels
	 *
	 * usage: qList->add(QVariant::value(Channel*)
	 */
	virtual void setChannellist(const QList<KalvaData::Channel*> & list = QList<KalvaData::Channel*>()) = 0;
	virtual void addChannel(KalvaData::Channel * channel) = 0;
	virtual void removeChannel(KalvaData::Channel * channel) = 0;
	virtual const QList<KalvaData::Channel*>& getChannellist() = 0;

};

}
Q_DECLARE_INTERFACE( KalvaPlugin::ChannellistProviderInterface, "org.kde.apps.kalva2.ChannellistProviderInterface/1.0" )

#endif
