/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef ETRANSFORMCMD_H
#define ETRANSFORMCMD_H

#include "ecommand.h"
#include <qptrlist.h>

class ElementNode;
class Transform;
class TransformList;
/**
Applies a Transform attribute to an element
or adds a AnimateTransformElement
 
@author Hans Oischinger
*/
class ETransformCMD : public ECommand
{
public:
  ETransformCMD( Transform* transform );
  ETransformCMD( TransformList* transformlist );
  ETransformCMD( ElementNode* element, Transform* transform );
  ~ETransformCMD();

  virtual bool visit( VectorElement& element );

  void execute();
  void unexecute();

private:
  ElementSelection* m_selection;
  //Transform *m_transform; // the transformation we applied in execute()
  TransformList *m_tlist;
  QPtrList<AnimateTransformElement> m_animlist; // the list of Elements created
  bool m_dontdelete_m_tlist;  // should we delete m_transform on destruction
  bool m_removed; // True if the AnimateElement created by this command has been removed 
                  // and can be deleted in the destructor
};

#endif
