/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef TIMELINEDOCKER_H
#define TIMELINEDOCKER_H

#include "ddocker.h"
#include "core/coreinterfaces.h"

// class TimelineTable;
class ElementTreeView;
class TimelineView;
class QHBox;
/**
@author Hans Oischinger
*/
class TimelineDocker : public DDocker, public ElementListenerInterface
{
  Q_OBJECT
public:
  TimelineDocker(QWidget *parent = 0, const char *name = 0);
  ~TimelineDocker();

  // ElementListenerInterface
  void onElementInserted( ElementNode* );
  void onElementRemoved( ElementNode* ) {}
  void onElementModified( ElementNode* ) {}

protected:
  virtual void resizeEvent ( QResizeEvent * );

protected slots:
  /**
   * Convenience function which gets the x and y values from m_listview
   */
  void elemTreeViewportChanged();
  /**
   * Hides all labels on m_timeline and shows the labels for the elements currently
   * displayed on m_listview
   */
  void elemTreeViewportChanged(int x, int y);

private:
  //   TimelineTable *m_table;
  ElementTreeView* m_listview;
  TimelineView* m_timeline;
  QHBox *m_hbox;
};

#endif
