/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef NUMBER_H
#define NUMBER_H

#include "attribute.h"
#include <qstring.h>

/**
@author Hans Oischinger
*/
class Number : public Attribute
{
public:
  enum NumType { NUM_UNSPECIFIED,
                 NUM_INT,
                 NUM_PERCENTAGE };

  Number();
  Number( double value, unsigned int type = NUM_INT );
  Number( const QString& numstr );
  Number( const Number& );
  ~Number();

  Number &operator=(const Number&);
  virtual Attribute* clone();

  bool operator==(const Number &);
  bool operator!=(const Number &);

  virtual void accept( AVisitor& );

  unsigned int numType() const { return m_numType; }
  double floatValue() const;
  double percentValue() const;
  double value() const { return m_value; }
  void setValue( double d );

protected:
  double m_value;
  unsigned int m_numType;
};

#endif
