/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef USEELEMENT_H
#define USEELEMENT_H

#include "groupelement.h"

class KCanvasItem;
class URIReference;
/**
Just like svg's use-tag this class holds a reference to another ElementNode that has been defined elsewhere
 
@author Hans Oischinger
*/
class UseElement : public GroupElement
{
  Q_OBJECT
public:
  UseElement();
  ~UseElement();
  UseElement( const UseElement & );

  UseElement &operator=(const UseElement &);
  virtual ElementNode *clone();

  virtual Attribute* getAttrByName( const QString& name );
  virtual void accept( Visitor& visitor );
  virtual Element::Hit hits( const QPoint & );
  virtual QRect bbox( KCBBoxFlags flags = BBOX_DEFAULT ) const;

  URIReference& ref() const { return *m_ref; }

protected:
  URIReference* m_ref;
};

#endif
