/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/

#ifndef RGBSELWIDGETIMPL_H
#define RGBSELWIDGETIMPL_H

#include "rgbselwidget.h"

class QColor;
class RGBSelWidgetImpl : public RGBSelWidget
{
  Q_OBJECT
public:
  RGBSelWidgetImpl(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~RGBSelWidgetImpl();

  QColor value() const;

public slots:
  void setValue(const QColor& c);

signals:
  void valueChanged(const QColor&);

protected slots:
  void slotSpinBoxGreenValChanged( int i );
  void slotSpinBoxRedValChanged( int i );
  void slotSpinBoxBlueValChanged( int i );
  void recalcColor();

private:
  QColor *m_currentColor;
};

#endif

