/*
Copyright 2008  Nathan Bradshaw nathanlbradshaw@gmail.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public 
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MBHTTPSERVICE_H
#define MBHTTPSERVICE_H

#include "statelessservice.h"


#include <QtCore/QString>
#include <KUrl>

#include "servicemodel_export.h"

// Namespace
namespace ServiceModel { 

class SERVICEMODEL_EXPORT HttpService : public StatelessService {

   public:
      HttpService (QObject *parent = 0);
      virtual ~HttpService();
      
      // assign the service a URL. This should be the base URL to which query strings are passed
      void setBaseUrl (KUrl url);
      
      KUrl baseUrl ();

   protected:
      
   private:
      KUrl m_url;
};
} 
#endif //MBHTTPSERVICE_H

