/*  This file is part of the KDE project
    Copyright (C) 2007 Matthias Kretz <kretz@kde.org>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License version 2 as published by the Free Software Foundation.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef MIXERCONTROLSET_P_H
#define MIXERCONTROLSET_P_H

#include "mixercontrolset.h"
#include "mixer_p.h"
#include "mixercontrol_p.h"
#include <QtCore/QExplicitlySharedDataPointer>
#include <QtCore/QSharedData>

namespace Phonon
{
namespace Mixer
{

class MixerControlSetSharedData : public QSharedData
{
    friend class MixerControlSet;
    friend class MixerSharedData;
    public:
        MixerControlSetSharedData(const QString &name, const QIcon &icon) : m_name(name), m_icon(icon) {}
        typedef QExplicitlySharedDataPointer<MixerControlSetSharedData> Ptr;

    private:
        MixerSharedData::Ptr m_mixer;
        QString m_name;
        QIcon m_icon;
};

class MixerControlSetPrivate
{
    friend class MixerSharedData;
    Q_DECLARE_PUBLIC(MixerControlSet)
    K_DECLARE_SHARED(MixerControlSet)
    public:
        void addControl(const MixerControlSharedData::Ptr &c) {}

    protected:
        MixerControlSet *q_ptr;
        MixerControlSetSharedData::Ptr s_ptr;
};

} // namespace Mixer
} // namespace Phonon
#endif // MIXERCONTROLSET_P_H
